package dev.pfaff.altargui.util;

import java.lang.invoke.MethodHandle;
import java.lang.invoke.MethodHandles;
import java.lang.invoke.MethodType;
import java.lang.invoke.VarHandle;

import static java.lang.invoke.MethodHandles.insertCoordinates;

public final class MethodHandleUtil {
    public static MethodHandle findStatic(MethodHandles.Lookup lookup, Class<?> refc, String name, MethodType type) {
        try {
            return lookup.findStatic(refc, name, type);
        } catch (NoSuchMethodException | IllegalAccessException e) {
            throw new RuntimeException(e);
        }
    }

    public static VarHandle withoutBase(VarHandle varHandle) {
        return insertCoordinates(varHandle, 1, 0L);
    }
}
